



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LruCache缓存</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LruCache缓存</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 23:27:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>LruCache通常用于实现内存缓存，采用的缓存算法是LRU（Least&nbsp;Recently&nbsp;Used）即近期最少使用算法，其核心思想是：当缓存满的时候，会优先淘汰那些近期最少使用的缓存对象。</strong></p>
<p><em><strong>1.LruCache是Android 3.1提供的缓存类，在使用LruCache的时候建议采用support-v4兼容包中提供的LruCache，这样才能兼容Android 2.2版本。</strong></em></p>
<p><em><strong>2.LruCache是一个泛型类，内部采用一个LinkedHashMap以强引用的方式存储外界的缓存对象，当缓存满的时候，会移除较早使用的缓存对象，然后再添加新的缓存对象。</strong></em></p>
<p><em><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;强引用：直接的对象引用。</strong></em></p>
<p><em><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;软引用：当一个对象只有软引用存在时，系统内存不足时此对象会被gc回收。</strong></em></p>
<p><em><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;弱引用：当一个对象只有弱引用存在时，此对象会随时被gc回收。</strong></em></p>
<p><em><strong>简单的使用：</strong></em></p>
<p><em><strong>&nbsp;&nbsp;&nbsp;&nbsp;1.初始化</strong></em></p>
<div>
<pre class="prettyprint linenums">int maxMemory = (int) (Runtime.getRuntime().maxMemory()/);<br />
int cacheMemory = maxMemory/;<br />
mLruCache = new LruCache&lt;String,Bitmap&gt;(cacheMemory){<br />
            @Override<br />
            protected int sizeOf(String key, Bitmap value) {//sizeOf的作用是计算缓存对象的大小<br />
                return value.getRowBytes() * value.getHeight()/;<br />
            }<br />
        };</pre>
</div>
<p><em><strong>//sizeOf的作用是计算缓存对象的大小,单位要和总容量的单位一致，这里为KB（除了1024）</strong></em></p>
<p><em><strong>2.获取</strong></em></p>
<div>
<pre class="prettyprint linenums">mLruCache.get(key);</pre>
</div>
<p><em><strong>3.添加</strong></em></p>
<div>
<pre class="prettyprint linenums">mLruCache.put(key,bitmap);</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k7yj9j.html">html&plus;ccs3太阳系行星运转动画之土星有个环，地球有颗小卫星</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw47v38.html">java 驼峰字符和下划线字符相互转换工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96rrmv9.html">Oracle中改变表的Owner和tablespace</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xgjgz8.html">Erlang库 -- 有意思的库汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdn6vd8.html">菜鸟的js学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm67w09.html">CART剪枝</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnp7nj8.html">windows----composer、laravel安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpn0e39.html">树列复选框Extjs</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k4xj29.html">curl---一款实用的URL命令行网络通讯工具&sol;库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1ovm2q.html">Cocos2d-x 3&period;0 Android改动APK名、更改图标、改动屏幕方向、改动版本，一些须要注意的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0vdnq.html">常见jquery面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jk5g3q.html">html5学习笔记3&mdash;&mdash;高级特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jd66jq.html">用maven创建一个web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyey039.html">SQL 读取csv 文件批量插入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjdo739.html">FFmpeg封装格式处理4-转封装例程</a>
		</li>
						<li><a href="https://www.batexi.com/a/960v2yj9.html">python r（不进行转义）的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1e3119.html">利用顺序栈解决括号匹配问题（c&plus;&plus;）-- 数据结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1opm09.html">C&num; XtraGrid的行指示器&lpar;RowIndicator&rpar;行号以及图标设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jme08.html">JProfiler性能分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv67n2q.html">【转】&period;NET Core基于&period; csproj 配置文件发布项目</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqllxo6q.html">Android的PopWindow动画实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv276o9.html">NFS Volume Provider（Part III） - 每天5分钟玩转 OpenStack（64）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gjye79.html">【jQuery小实例】---3  凤凰网首页图片动态效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r5l44q.html">SYSTEM表空间AUD&dollar;使用空间过大问题处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zy7x39.html">重温Servlet学习笔记--编码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdg7v9.html">源码阅读系列：EventBus</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7o53e8.html">多个 App 间启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxd3xz9.html">【十大经典数据挖掘算法】Apriori</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4j075q.html">Sublime插件支持Sass编译和Babel解析ES6 &amp;amp&semi; &period;sublime-build文件初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv246z9.html">Parallel并行编程初步</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
